//genesis

// ************************************************************************
// *
// *                   Parallel GENESIS test suite
// *
// ************************************************************************
// *
// *    look1.t3d.g - Basic test of lookahead with one active message
// *
// ************************************************************************
// $Log: look1.t3d.g,v $
// Revision 1.1  1997/05/20 17:21:50  ghood
// Initial revision
//
//

function sleep (t)
    int t
    int i, j

    for (i = 0; i < t; i = i + 1)
	for (j = 0; j < 20000; j = j + 1)
	end
    end
end

paron -parallel -debug 0 -silent 2 -nodes 3 -output look1.out \
	-altsimrc ../.simrc -executable pargenbeta

int my_node = {mynode}
int n_node = {nnodes}
int my_zone = {myzone}
int n_zones = {nzones}

// nodes 1 and 2 send ACTIVEL messages to node 0
// we test lookahead by having nodes 1 and/or 2 sleep before steps
// node 0 should wait for them

if ({my_node} != 0)
	create dbg /dbg
else
	create dbg /dbg1
	create dbg /dbg2
end
barrier

if ({my_node} != 0)
	raddmsg /dbg /dbg{mynode}@0 ACTIVEL
end

reset

if ({my_node} == 0)
	setfield /dbg1 delay 3 weight 1
	setfield /dbg2 delay 6 weight 1
end

barrier

// with nodes synchrnoized on steps
if ({mynode} == 0)
	echo NODES SYNCHRONIZED ON STEPS
end

barrier

if ({mynode} != 0)
//	send an event
	setfield /dbg init_value -1
	step
	echo@0 {mynode}: sent event, sleeping...
	sleep 5
	setfield /dbg init_value 0
	echo@0 {mynode}: awoke, stepping...
	step 6
else
//	receive the events
	step 7
end


// with nodes not synchronized on steps
barrier

if ({mynode} == 0)
	echo NODES NOT SYNCHRONIZED ON STEPS
end

barrier

setfield /post sync_before_step 0

if ({mynode} != 0)
//	send an event
	setfield /dbg init_value -1
	step
	echo@0 {mynode}: sent event, sleeping...
	sleep 5
	setfield /dbg init_value 0
	echo@0 {mynode}: awoke, stepping...
	step 6
else
//	receive the events
	echo {mynode}: stepping...
	step 7
end

// with nodes not synchronized on steps and lookahead
barrier

if ({mynode} == 0)
	echo NODES NOT SYNCHRONIZED ON STEPS AND LOOKAHEAD
end

barrier

showlookahead
if ({mynode} == 0)
	setlookahead 1 3
	setlookahead 2 6
end
showlookahead
echo node 0 getlookahead is {getlookahead 0}
echo node 1 getlookahead is {getlookahead 1}
echo node 2 getlookahead is {getlookahead 2}

if ({mynode} != 0)
//	send an event
	setfield /dbg init_value -1
	step
	echo@0 {mynode}: sent event, sleeping... 
	sleep 5
	setfield /dbg init_value 0
	echo@0 {mynode}: awoke, stepping...
	step 10
else
//	receive the events
	echo {mynode}: stepping...
	step 11
end

paroff
quit
